/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.ClearanceForPlace;
import org.openapitools.client.model.Entry;
import org.openapitools.client.model.NewEntryWithLicense;
import org.openapitools.client.model.NewEntryWithVersion;
//import org.openapitools.client.model.OneOfobject;
import org.openapitools.client.model.PendingClearanceForPlace;
import org.openapitools.client.model.PlaceHistory;
import org.openapitools.client.model.ResultCount;
import org.openapitools.client.model.Review;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class EntriesPlacesApi {
    private ApiClient localVarApiClient;

    public EntriesPlacesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public EntriesPlacesApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for entriesIdPut
     * @param id  (required)
     * @param newEntryWithVersion  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesIdPutCall(String id, NewEntryWithVersion newEntryWithVersion, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = newEntryWithVersion;

        // create path and map variables
        String localVarPath = "/entries/{id}"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth", "captchaCookieAuth", "jwtAuth", "userEmailCookieAuth" };
        return localVarApiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call entriesIdPutValidateBeforeCall(String id, NewEntryWithVersion newEntryWithVersion, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling entriesIdPut(Async)");
        }
        
        // verify the required parameter 'newEntryWithVersion' is set
        if (newEntryWithVersion == null) {
            throw new ApiException("Missing the required parameter 'newEntryWithVersion' when calling entriesIdPut(Async)");
        }
        

        okhttp3.Call localVarCall = entriesIdPutCall(id, newEntryWithVersion, _callback);
        return localVarCall;

    }

    /**
     * Update an entry
     * The edited entry must include the *next version* of this entry in the &#x60;version&#x60; field, where *next version* &#x3D; *current version* + 1. 
     * @param id  (required)
     * @param newEntryWithVersion  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public void entriesIdPut(String id, NewEntryWithVersion newEntryWithVersion) throws ApiException {
        entriesIdPutWithHttpInfo(id, newEntryWithVersion);
    }

    /**
     * Update an entry
     * The edited entry must include the *next version* of this entry in the &#x60;version&#x60; field, where *next version* &#x3D; *current version* + 1. 
     * @param id  (required)
     * @param newEntryWithVersion  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> entriesIdPutWithHttpInfo(String id, NewEntryWithVersion newEntryWithVersion) throws ApiException {
        okhttp3.Call localVarCall = entriesIdPutValidateBeforeCall(id, newEntryWithVersion, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Update an entry (asynchronously)
     * The edited entry must include the *next version* of this entry in the &#x60;version&#x60; field, where *next version* &#x3D; *current version* + 1. 
     * @param id  (required)
     * @param newEntryWithVersion  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesIdPutAsync(String id, NewEntryWithVersion newEntryWithVersion, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = entriesIdPutValidateBeforeCall(id, newEntryWithVersion, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for entriesIdsGet
     * @param ids  (required)
     * @param orgTag A single hash tag that is moderated by an organization.  Results will be filtered according to the current clearance status. Unclear revisions of entries will either be removed or replaced by older, already cleared revisions. Unclear revisions of entries are expected to only exist temporarily for a short time frame until a newer version has been cleared.  If the provided hash tag is not moderated by any organization the results will not be filtered by clearance status.  Only a single tag can be specified, because filtering according to clearance by multiple organizations could produce ambiguous and conflicting results.  Only when used in search requests: The hash tag will be included in the query as a mandatory search criteria like any other tag. Omitting this parameter and instead appending the moderated hash tag as a regular tag to the &#x60;tags&#x60; parameter will also return unfiltered search results, i.e. current revisions of entries independent of their clearance status.  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesIdsGetCall(String ids, String orgTag, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/entries/{ids}"
            .replaceAll("\\{" + "ids" + "\\}", localVarApiClient.escapeString(ids.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (orgTag != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("org_tag", orgTag));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call entriesIdsGetValidateBeforeCall(String ids, String orgTag, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'ids' is set
        if (ids == null) {
            throw new ApiException("Missing the required parameter 'ids' when calling entriesIdsGet(Async)");
        }
        

        okhttp3.Call localVarCall = entriesIdsGetCall(ids, orgTag, _callback);
        return localVarCall;

    }

    /**
     * Get multiple entries
     * 
     * @param ids  (required)
     * @param orgTag A single hash tag that is moderated by an organization.  Results will be filtered according to the current clearance status. Unclear revisions of entries will either be removed or replaced by older, already cleared revisions. Unclear revisions of entries are expected to only exist temporarily for a short time frame until a newer version has been cleared.  If the provided hash tag is not moderated by any organization the results will not be filtered by clearance status.  Only a single tag can be specified, because filtering according to clearance by multiple organizations could produce ambiguous and conflicting results.  Only when used in search requests: The hash tag will be included in the query as a mandatory search criteria like any other tag. Omitting this parameter and instead appending the moderated hash tag as a regular tag to the &#x60;tags&#x60; parameter will also return unfiltered search results, i.e. current revisions of entries independent of their clearance status.  (optional)
     * @return List&lt;Entry&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public List<Entry> entriesIdsGet(String ids, String orgTag) throws ApiException {
        ApiResponse<List<Entry>> localVarResp = entriesIdsGetWithHttpInfo(ids, orgTag);
        return localVarResp.getData();
    }

    /**
     * Get multiple entries
     * 
     * @param ids  (required)
     * @param orgTag A single hash tag that is moderated by an organization.  Results will be filtered according to the current clearance status. Unclear revisions of entries will either be removed or replaced by older, already cleared revisions. Unclear revisions of entries are expected to only exist temporarily for a short time frame until a newer version has been cleared.  If the provided hash tag is not moderated by any organization the results will not be filtered by clearance status.  Only a single tag can be specified, because filtering according to clearance by multiple organizations could produce ambiguous and conflicting results.  Only when used in search requests: The hash tag will be included in the query as a mandatory search criteria like any other tag. Omitting this parameter and instead appending the moderated hash tag as a regular tag to the &#x60;tags&#x60; parameter will also return unfiltered search results, i.e. current revisions of entries independent of their clearance status.  (optional)
     * @return ApiResponse&lt;List&lt;Entry&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<Entry>> entriesIdsGetWithHttpInfo(String ids, String orgTag) throws ApiException {
        okhttp3.Call localVarCall = entriesIdsGetValidateBeforeCall(ids, orgTag, null);
        Type localVarReturnType = new TypeToken<List<Entry>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get multiple entries (asynchronously)
     * 
     * @param ids  (required)
     * @param orgTag A single hash tag that is moderated by an organization.  Results will be filtered according to the current clearance status. Unclear revisions of entries will either be removed or replaced by older, already cleared revisions. Unclear revisions of entries are expected to only exist temporarily for a short time frame until a newer version has been cleared.  If the provided hash tag is not moderated by any organization the results will not be filtered by clearance status.  Only a single tag can be specified, because filtering according to clearance by multiple organizations could produce ambiguous and conflicting results.  Only when used in search requests: The hash tag will be included in the query as a mandatory search criteria like any other tag. Omitting this parameter and instead appending the moderated hash tag as a regular tag to the &#x60;tags&#x60; parameter will also return unfiltered search results, i.e. current revisions of entries independent of their clearance status.  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesIdsGetAsync(String ids, String orgTag, final ApiCallback<List<Entry>> _callback) throws ApiException {

        okhttp3.Call localVarCall = entriesIdsGetValidateBeforeCall(ids, orgTag, _callback);
        Type localVarReturnType = new TypeToken<List<Entry>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for entriesMostPopularTagsGet
     * @param minCount Minimum count per tag (inclusive) (optional)
     * @param maxCount Maximum count per tag (inclusive) (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesMostPopularTagsGetCall(Long minCount, Long maxCount, Long limit, Long offset, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/entries/most-popular-tags";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (minCount != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min_count", minCount));
        }

        if (maxCount != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max_count", maxCount));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (offset != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("offset", offset));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call entriesMostPopularTagsGetValidateBeforeCall(Long minCount, Long maxCount, Long limit, Long offset, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = entriesMostPopularTagsGetCall(minCount, maxCount, limit, offset, _callback);
        return localVarCall;

    }

    /**
     * Get most popular tags for entries
     * Get most popular tags for entries with their total usage count. Results are sorted in descending order of counts, i.e. most popular tags appear first. A maximum of 1000 tag with their count is returned if no limit is specifid. 
     * @param minCount Minimum count per tag (inclusive) (optional)
     * @param maxCount Maximum count per tag (inclusive) (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @return List&lt;List&lt;OneOfobject&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
//    public List<List<OneOfobject>> entriesMostPopularTagsGet(Long minCount, Long maxCount, Long limit, Long offset) throws ApiException {
//        ApiResponse<List<List<OneOfobject>>> localVarResp = entriesMostPopularTagsGetWithHttpInfo(minCount, maxCount, limit, offset);
//        return localVarResp.getData();
//    }

    /**
     * Get most popular tags for entries
     * Get most popular tags for entries with their total usage count. Results are sorted in descending order of counts, i.e. most popular tags appear first. A maximum of 1000 tag with their count is returned if no limit is specifid. 
     * @param minCount Minimum count per tag (inclusive) (optional)
     * @param maxCount Maximum count per tag (inclusive) (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @return ApiResponse&lt;List&lt;List&lt;OneOfobject&gt;&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
//    public ApiResponse<List<List<OneOfobject>>> entriesMostPopularTagsGetWithHttpInfo(Long minCount, Long maxCount, Long limit, Long offset) throws ApiException {
//        okhttp3.Call localVarCall = entriesMostPopularTagsGetValidateBeforeCall(minCount, maxCount, limit, offset, null);
//        Type localVarReturnType = new TypeToken<List<List<OneOfobject>>>(){}.getType();
//        return localVarApiClient.execute(localVarCall, localVarReturnType);
//    }

    /**
     * Get most popular tags for entries (asynchronously)
     * Get most popular tags for entries with their total usage count. Results are sorted in descending order of counts, i.e. most popular tags appear first. A maximum of 1000 tag with their count is returned if no limit is specifid. 
     * @param minCount Minimum count per tag (inclusive) (optional)
     * @param maxCount Maximum count per tag (inclusive) (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
//    public okhttp3.Call entriesMostPopularTagsGetAsync(Long minCount, Long maxCount, Long limit, Long offset, final ApiCallback<List<List<OneOfobject>>> _callback) throws ApiException {
//
//        okhttp3.Call localVarCall = entriesMostPopularTagsGetValidateBeforeCall(minCount, maxCount, limit, offset, _callback);
//        Type localVarReturnType = new TypeToken<List<List<OneOfobject>>>(){}.getType();
//        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
//        return localVarCall;
//    }
    /**
     * Build call for entriesPost
     * @param newEntryWithLicense  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesPostCall(NewEntryWithLicense newEntryWithLicense, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = newEntryWithLicense;

        // create path and map variables
        String localVarPath = "/entries";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth", "captchaCookieAuth", "jwtAuth", "userEmailCookieAuth" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call entriesPostValidateBeforeCall(NewEntryWithLicense newEntryWithLicense, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'newEntryWithLicense' is set
        if (newEntryWithLicense == null) {
            throw new ApiException("Missing the required parameter 'newEntryWithLicense' when calling entriesPost(Async)");
        }
        

        okhttp3.Call localVarCall = entriesPostCall(newEntryWithLicense, _callback);
        return localVarCall;

    }

    /**
     * Create an entry
     * 
     * @param newEntryWithLicense  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public void entriesPost(NewEntryWithLicense newEntryWithLicense) throws ApiException {
        entriesPostWithHttpInfo(newEntryWithLicense);
    }

    /**
     * Create an entry
     * 
     * @param newEntryWithLicense  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> entriesPostWithHttpInfo(NewEntryWithLicense newEntryWithLicense) throws ApiException {
        okhttp3.Call localVarCall = entriesPostValidateBeforeCall(newEntryWithLicense, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Create an entry (asynchronously)
     * 
     * @param newEntryWithLicense  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesPostAsync(NewEntryWithLicense newEntryWithLicense, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = entriesPostValidateBeforeCall(newEntryWithLicense, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for entriesRecentlyChangedGet
     * @param since Time stamp of the oldest change (inclusive) (optional)
     * @param until Time stamp of the most recent change (exclusive) (optional)
     * @param withRatings Return entries including their ratings (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesRecentlyChangedGetCall(Long since, Long until, Boolean withRatings, Long limit, Long offset, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/entries/recently-changed";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (since != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("since", since));
        }

        if (until != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("until", until));
        }

        if (withRatings != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("with_ratings", withRatings));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (offset != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("offset", offset));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call entriesRecentlyChangedGetValidateBeforeCall(Long since, Long until, Boolean withRatings, Long limit, Long offset, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = entriesRecentlyChangedGetCall(since, until, withRatings, limit, offset, _callback);
        return localVarCall;

    }

    /**
     * Get recently changed entries
     * Get recently changed entries that have been created/updated/archived between since and now. Limitation: Only the most recent 1000 entries are returned and the change history is restricted to the last 100 days. 
     * @param since Time stamp of the oldest change (inclusive) (optional)
     * @param until Time stamp of the most recent change (exclusive) (optional)
     * @param withRatings Return entries including their ratings (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @return Entry
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public Entry entriesRecentlyChangedGet(Long since, Long until, Boolean withRatings, Long limit, Long offset) throws ApiException {
        ApiResponse<Entry> localVarResp = entriesRecentlyChangedGetWithHttpInfo(since, until, withRatings, limit, offset);
        return localVarResp.getData();
    }

    /**
     * Get recently changed entries
     * Get recently changed entries that have been created/updated/archived between since and now. Limitation: Only the most recent 1000 entries are returned and the change history is restricted to the last 100 days. 
     * @param since Time stamp of the oldest change (inclusive) (optional)
     * @param until Time stamp of the most recent change (exclusive) (optional)
     * @param withRatings Return entries including their ratings (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @return ApiResponse&lt;Entry&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Entry> entriesRecentlyChangedGetWithHttpInfo(Long since, Long until, Boolean withRatings, Long limit, Long offset) throws ApiException {
        okhttp3.Call localVarCall = entriesRecentlyChangedGetValidateBeforeCall(since, until, withRatings, limit, offset, null);
        Type localVarReturnType = new TypeToken<Entry>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get recently changed entries (asynchronously)
     * Get recently changed entries that have been created/updated/archived between since and now. Limitation: Only the most recent 1000 entries are returned and the change history is restricted to the last 100 days. 
     * @param since Time stamp of the oldest change (inclusive) (optional)
     * @param until Time stamp of the most recent change (exclusive) (optional)
     * @param withRatings Return entries including their ratings (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call entriesRecentlyChangedGetAsync(Long since, Long until, Boolean withRatings, Long limit, Long offset, final ApiCallback<Entry> _callback) throws ApiException {

        okhttp3.Call localVarCall = entriesRecentlyChangedGetValidateBeforeCall(since, until, withRatings, limit, offset, _callback);
        Type localVarReturnType = new TypeToken<Entry>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for placesClearanceCountGet
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesClearanceCountGetCall(final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/places/clearance/count";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call placesClearanceCountGetValidateBeforeCall(final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = placesClearanceCountGetCall(_callback);
        return localVarCall;

    }

    /**
     * Count clearance of places
     * Returns the total number places with pending clearance on behalf of the requesting organization.  Requests must include the API token of the organization. 
     * @return ResultCount
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ResultCount placesClearanceCountGet() throws ApiException {
        ApiResponse<ResultCount> localVarResp = placesClearanceCountGetWithHttpInfo();
        return localVarResp.getData();
    }

    /**
     * Count clearance of places
     * Returns the total number places with pending clearance on behalf of the requesting organization.  Requests must include the API token of the organization. 
     * @return ApiResponse&lt;ResultCount&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ResultCount> placesClearanceCountGetWithHttpInfo() throws ApiException {
        okhttp3.Call localVarCall = placesClearanceCountGetValidateBeforeCall(null);
        Type localVarReturnType = new TypeToken<ResultCount>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Count clearance of places (asynchronously)
     * Returns the total number places with pending clearance on behalf of the requesting organization.  Requests must include the API token of the organization. 
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesClearanceCountGetAsync(final ApiCallback<ResultCount> _callback) throws ApiException {

        okhttp3.Call localVarCall = placesClearanceCountGetValidateBeforeCall(_callback);
        Type localVarReturnType = new TypeToken<ResultCount>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for placesClearanceGet
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesClearanceGetCall(Long limit, Long offset, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/places/clearance";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (offset != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("offset", offset));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call placesClearanceGetValidateBeforeCall(Long limit, Long offset, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = placesClearanceGetCall(limit, offset, _callback);
        return localVarCall;

    }

    /**
     * List clearance of places
     * Returns a list of places with pending clearance on behalf of the requesting organization in chronological order.  Requests must include the API token of the organization. 
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @return List&lt;PendingClearanceForPlace&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public List<PendingClearanceForPlace> placesClearanceGet(Long limit, Long offset) throws ApiException {
        ApiResponse<List<PendingClearanceForPlace>> localVarResp = placesClearanceGetWithHttpInfo(limit, offset);
        return localVarResp.getData();
    }

    /**
     * List clearance of places
     * Returns a list of places with pending clearance on behalf of the requesting organization in chronological order.  Requests must include the API token of the organization. 
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @return ApiResponse&lt;List&lt;PendingClearanceForPlace&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<PendingClearanceForPlace>> placesClearanceGetWithHttpInfo(Long limit, Long offset) throws ApiException {
        okhttp3.Call localVarCall = placesClearanceGetValidateBeforeCall(limit, offset, null);
        Type localVarReturnType = new TypeToken<List<PendingClearanceForPlace>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * List clearance of places (asynchronously)
     * Returns a list of places with pending clearance on behalf of the requesting organization in chronological order.  Requests must include the API token of the organization. 
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param offset Number of items to skip in the result list or 0 if unspecified.  The pagination offset is only evaluated in conjunction with the corresponding pagination limit parameter!  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesClearanceGetAsync(Long limit, Long offset, final ApiCallback<List<PendingClearanceForPlace>> _callback) throws ApiException {

        okhttp3.Call localVarCall = placesClearanceGetValidateBeforeCall(limit, offset, _callback);
        Type localVarReturnType = new TypeToken<List<PendingClearanceForPlace>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for placesClearancePost
     * @param clearanceForPlace  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesClearancePostCall(List<ClearanceForPlace> clearanceForPlace, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = clearanceForPlace;

        // create path and map variables
        String localVarPath = "/places/clearance";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call placesClearancePostValidateBeforeCall(List<ClearanceForPlace> clearanceForPlace, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'clearanceForPlace' is set
        if (clearanceForPlace == null) {
            throw new ApiException("Missing the required parameter 'clearanceForPlace' when calling placesClearancePost(Async)");
        }
        

        okhttp3.Call localVarCall = placesClearancePostCall(clearanceForPlace, _callback);
        return localVarCall;

    }

    /**
     * Update clearance of places
     * Update the clearance of multiple places on behalf of the requesting organization.  Returns the number of created/updated clearance records.  If the given revision matches the current revision of that place then any pending clearance is deleted. Otherwise clearance will remain pending with the given revision stored as the new last cleared revision, i.e. any pending clearance is replaced.  Requests must include the API token of the organization. 
     * @param clearanceForPlace  (required)
     * @return ResultCount
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ResultCount placesClearancePost(List<ClearanceForPlace> clearanceForPlace) throws ApiException {
        ApiResponse<ResultCount> localVarResp = placesClearancePostWithHttpInfo(clearanceForPlace);
        return localVarResp.getData();
    }

    /**
     * Update clearance of places
     * Update the clearance of multiple places on behalf of the requesting organization.  Returns the number of created/updated clearance records.  If the given revision matches the current revision of that place then any pending clearance is deleted. Otherwise clearance will remain pending with the given revision stored as the new last cleared revision, i.e. any pending clearance is replaced.  Requests must include the API token of the organization. 
     * @param clearanceForPlace  (required)
     * @return ApiResponse&lt;ResultCount&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ResultCount> placesClearancePostWithHttpInfo(List<ClearanceForPlace> clearanceForPlace) throws ApiException {
        okhttp3.Call localVarCall = placesClearancePostValidateBeforeCall(clearanceForPlace, null);
        Type localVarReturnType = new TypeToken<ResultCount>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Update clearance of places (asynchronously)
     * Update the clearance of multiple places on behalf of the requesting organization.  Returns the number of created/updated clearance records.  If the given revision matches the current revision of that place then any pending clearance is deleted. Otherwise clearance will remain pending with the given revision stored as the new last cleared revision, i.e. any pending clearance is replaced.  Requests must include the API token of the organization. 
     * @param clearanceForPlace  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesClearancePostAsync(List<ClearanceForPlace> clearanceForPlace, final ApiCallback<ResultCount> _callback) throws ApiException {

        okhttp3.Call localVarCall = placesClearancePostValidateBeforeCall(clearanceForPlace, _callback);
        Type localVarReturnType = new TypeToken<ResultCount>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for placesIdHistoryRevisionGet
     * @param id  (required)
     * @param revision  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesIdHistoryRevisionGetCall(String id, Long revision, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/places/{id}/history/{revision}"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "revision" + "\\}", localVarApiClient.escapeString(revision.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call placesIdHistoryRevisionGetValidateBeforeCall(String id, Long revision, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling placesIdHistoryRevisionGet(Async)");
        }
        
        // verify the required parameter 'revision' is set
        if (revision == null) {
            throw new ApiException("Missing the required parameter 'revision' when calling placesIdHistoryRevisionGet(Async)");
        }
        

        okhttp3.Call localVarCall = placesIdHistoryRevisionGetCall(id, revision, _callback);
        return localVarCall;

    }

    /**
     * History of place revisions
     * Loads the history of all place revisions including status reviews.  Optionally the result can be restricted to a single revision. If no particular revision is requested then all revisions are returned.  Results are sorted in descending chronological order of activity time stamps, i.e. the most recent changes appear first.  Only users with the role scout or admin are entitled to invoke this function. Organizations must provide their API token for authorization. 
     * @param id  (required)
     * @param revision  (required)
     * @return PlaceHistory
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public PlaceHistory placesIdHistoryRevisionGet(String id, Long revision) throws ApiException {
        ApiResponse<PlaceHistory> localVarResp = placesIdHistoryRevisionGetWithHttpInfo(id, revision);
        return localVarResp.getData();
    }

    /**
     * History of place revisions
     * Loads the history of all place revisions including status reviews.  Optionally the result can be restricted to a single revision. If no particular revision is requested then all revisions are returned.  Results are sorted in descending chronological order of activity time stamps, i.e. the most recent changes appear first.  Only users with the role scout or admin are entitled to invoke this function. Organizations must provide their API token for authorization. 
     * @param id  (required)
     * @param revision  (required)
     * @return ApiResponse&lt;PlaceHistory&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<PlaceHistory> placesIdHistoryRevisionGetWithHttpInfo(String id, Long revision) throws ApiException {
        okhttp3.Call localVarCall = placesIdHistoryRevisionGetValidateBeforeCall(id, revision, null);
        Type localVarReturnType = new TypeToken<PlaceHistory>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * History of place revisions (asynchronously)
     * Loads the history of all place revisions including status reviews.  Optionally the result can be restricted to a single revision. If no particular revision is requested then all revisions are returned.  Results are sorted in descending chronological order of activity time stamps, i.e. the most recent changes appear first.  Only users with the role scout or admin are entitled to invoke this function. Organizations must provide their API token for authorization. 
     * @param id  (required)
     * @param revision  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesIdHistoryRevisionGetAsync(String id, Long revision, final ApiCallback<PlaceHistory> _callback) throws ApiException {

        okhttp3.Call localVarCall = placesIdHistoryRevisionGetValidateBeforeCall(id, revision, _callback);
        Type localVarReturnType = new TypeToken<PlaceHistory>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for placesIdsReviewPost
     * @param ids  (required)
     * @param review  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 201 </td><td> Created a review for all places. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Parameters are missing or invalid </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesIdsReviewPostCall(String ids, Review review, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = review;

        // create path and map variables
        String localVarPath = "/places/{ids}/review"
            .replaceAll("\\{" + "ids" + "\\}", localVarApiClient.escapeString(ids.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call placesIdsReviewPostValidateBeforeCall(String ids, Review review, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'ids' is set
        if (ids == null) {
            throw new ApiException("Missing the required parameter 'ids' when calling placesIdsReviewPost(Async)");
        }
        
        // verify the required parameter 'review' is set
        if (review == null) {
            throw new ApiException("Missing the required parameter 'review' when calling placesIdsReviewPost(Async)");
        }
        

        okhttp3.Call localVarCall = placesIdsReviewPostCall(ids, review, _callback);
        return localVarCall;

    }

    /**
     * Review multiple places
     * Reviews the latest revision of multiple places at once. An audit log is written into the history of all place revisions. Dependening on the review status the affected places might be hidden from search results (archived, rejected) or re-appear (created, confirmed). Only scouts and admins are entitled to invoke this function. 
     * @param ids  (required)
     * @param review  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 201 </td><td> Created a review for all places. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Parameters are missing or invalid </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public void placesIdsReviewPost(String ids, Review review) throws ApiException {
        placesIdsReviewPostWithHttpInfo(ids, review);
    }

    /**
     * Review multiple places
     * Reviews the latest revision of multiple places at once. An audit log is written into the history of all place revisions. Dependening on the review status the affected places might be hidden from search results (archived, rejected) or re-appear (created, confirmed). Only scouts and admins are entitled to invoke this function. 
     * @param ids  (required)
     * @param review  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 201 </td><td> Created a review for all places. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Parameters are missing or invalid </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> placesIdsReviewPostWithHttpInfo(String ids, Review review) throws ApiException {
        okhttp3.Call localVarCall = placesIdsReviewPostValidateBeforeCall(ids, review, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Review multiple places (asynchronously)
     * Reviews the latest revision of multiple places at once. An audit log is written into the history of all place revisions. Dependening on the review status the affected places might be hidden from search results (archived, rejected) or re-appear (created, confirmed). Only scouts and admins are entitled to invoke this function. 
     * @param ids  (required)
     * @param review  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 201 </td><td> Created a review for all places. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Parameters are missing or invalid </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call placesIdsReviewPostAsync(String ids, Review review, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = placesIdsReviewPostValidateBeforeCall(ids, review, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
}
